#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# area_actuacion
class AreaActuacion < ActiveRecord::Base
  has_many :proyecto_x_area_actuacion, :dependent => :destroy
  has_many :proyecto, :through => :proyecto_x_area_actuacion, :uniq => true

  has_many :libro

  validates_uniqueness_of :nombre, :message => _("Nombre") +   _(" repetido.")
  validates_presence_of :nombre, :message => _("Nombre") + _(" no puede estar vacío.")

  before_destroy :verificar_borrado

  def verificar_borrado
    errors.add( "proyecto", _("hay proyectos")) unless self.proyecto.empty?
    errors.add_to_base( _("Una area de actuación tiene que estar vacio para poder ser borrado.") ) unless errors.empty?
    return false unless errors.empty?
  end
end
#done
