#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# documento

class Documento < ActiveRecord::Base
  # validates_presence_of :descripcion, :adjunto_filename
  has_many :comentario, :dependent => :destroy
  has_many :etiqueta_x_documento, :dependent => :destroy
  has_many :etiqueta, :through => :etiqueta_x_documento, :uniq => true
  #has_and_belongs_to_many :etiqueta, :join_table => :etiqueta_x_documento
  belongs_to :proyecto
  #belongs_to :financiacion
  belongs_to :usuario
  belongs_to :espacio

  validates_presence_of :espacio_id, :message => _("Espacio") + _(" no puede estar vacío.")

  # Guardar segun nos diga el environment
  # No usar nunca los nombres del archivo para las subidas!!!
  #has_attached_file :adjunto, :path => ENV["RAILS_VAR"] + "documento." + Digest::MD5.hexdigest(":basename :extension :id"),
  #has_attached_file :adjunto, :path => ":rails_root/documentos/:id/:basename.:extension",
  has_attached_file :adjunto, :path => ENV["RAILS_VAR"] + "documento.:id",
    :url => "descargar/:id"
  validates_attachment_presence :adjunto, :message => _("Tienes que subir por lo menos un documento")
  # validates_presence_of :descripcion, :message => _("Descripción") + _(" no puede estar vacía.")

end
