#--
#
#################################################################################
# Copyright 2011 CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# ActiveResource que devuelve usuarios

class Usuario < ActiveRecord::Base

  untranslate_all

  validates_uniqueness_of :nombre, :message => _("Nombre") +   _(" repetido.")
  validates_presence_of :contrasena, :message => _("Contraseña") + _(" no puede estar vacío.")
  validates_presence_of :nombre, :message => _("Nombre") + _(" no puede estar vacío.")
  validates_presence_of :correoe, :message => _("Correo") + _(" no puede estar vacío.")  

  has_many :comentario
  has_many :documento
  has_many :tarea, :dependent => :destroy
  #has_many :usuario_x_financiacion, :dependent => :destroy
  has_many :usuario_x_proyecto , :dependent => :destroy
  has_many :usuario_x_agente, :dependent => :destroy
  has_many :usuario_x_libro ,  :dependent => :destroy
  has_many :libro , :through => :usuario_x_libro, :conditions => ['bloqueado = ?', false]
  has_many :proyecto, :through => :usuario_x_proyecto
  has_many :financiacion, :through => :usuario_x_financiacion
  has_many :agente, :through => :usuario_x_agente
  
  #Para evitar destruir todos los usuarios, protegemos el usuario "admin"
  def before_destroy
    return false  if self.nombre == "admin"
  end

	# Metodo que hashea la contraseña
	def self.hash_contrasena(contrasena)
		Digest::SHA1.hexdigest(contrasena)
	end

	# Devuelve un Usuario, o un UsuarioR (dependiento de la variable ALFRESCO) para una contraseña y usuario determinado.
	def self.identificacion(usuario, contrasena)
		return find :first, :conditions => ["nombre = ? AND contrasena = ?", usuario, hash_contrasena(contrasena)]
	end


end

