class SubpartidaEnGastoXProyecto < ActiveRecord::Migration
  def self.up
    execute "DROP VIEW IF EXISTS `v_gasto`"
    add_column :gasto_x_proyecto, :subpartida_id, :integer

    Gasto.find(:all).each do |g|
      g.gasto_x_proyecto.first.update_attribute("subpartida_id", g.subpartida_id) if g.subpartida_id
    end

    remove_column :gasto, :subpartida_id
    execute <<-EOI1

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gasto` AS
select
A.id as financiador_id,A.nombre as financiador_nombre,
AI.id as implementador_id,AI.nombre as implementador_nombre,
AC.id as actividad_id,AC.codigo as actividad_codigo,AC.descripcion as actividad_nombre,
PY.id as proyecto_id, PY.nombre as proyecto_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
SPT.id as subpartida_id,SPT.nombre as subpartida_nombre,
PTF.id as partida_proyecto_id,PTF.nombre as partida_proyecto_nombre,
G.id as gasto_id,
G.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
PY.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
IFNULL(TCG.tasa_cambio,0) as tasa_cambio,
G.fecha,
((GXA.importe * GXAC.importe)/G.importe) as importe,
case when G.moneda_id = PY.moneda_id then
((GXA.importe * GXAC.importe)/G.importe)
else
((GXA.importe * GXAC.importe)/G.importe) * IFNULL(TCG.tasa_cambio,0)
end as importe_moneda_base


from
gasto_x_agente GXA
inner join gasto_x_actividad GXAC on GXA.gasto_id = GXAC.gasto_id and GXA.proyecto_id = GXAC.proyecto_id
inner join agente A on GXA.agente_id = A.id
inner join actividad AC on GXAC.actividad_id = AC.id
inner join gasto G on GXA.gasto_id = G.id
inner join libro L on G.libro_id = L.id
inner join agente AI on AI.id = L.agente_id
inner join moneda M on G.moneda_id = M.id
inner join gasto_x_proyecto GXP on GXP.gasto_id = G.id
inner join proyecto PY on GXP.proyecto_id = PY.id
left join moneda MAUX on MAUX.id = PY.moneda_id
left join tasa_cambio_gasto TCG on TCG.gasto_id = G.id and TCG.proyecto_id = PY.id
inner join partida PT on G.partida_id = PT.id
left join subpartida SPT on GXP.subpartida_id = SPT.id
left join partida_x_partida_financiacion PXPA on PT.id = PXPA.partida_id
left join partida_financiacion PTF on PTF.id = PXPA.partida_financiacion_id

EOI1
  
  end

  def self.down
    execute "DROP VIEW IF EXISTS `v_gasto`"
    remove_column :gasto_x_proyecto, :subpartida_id
    add_column :gasto, :subpartida_id, :integer
    execute <<-EOI2

CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gasto` AS
select
A.id as financiador_id,A.nombre as financiador_nombre,
AI.id as implementador_id,AI.nombre as implementador_nombre,
AC.id as actividad_id,AC.codigo as actividad_codigo,AC.descripcion as actividad_nombre,
PY.id as proyecto_id, PY.nombre as proyecto_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
SPT.id as subpartida_id,SPT.nombre as subpartida_nombre,
PTF.id as partida_proyecto_id,PTF.nombre as partida_proyecto_nombre,
G.id as gasto_id,
G.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
PY.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
IFNULL(TCG.tasa_cambio,0) as tasa_cambio,
G.fecha,
((GXA.importe * GXAC.importe)/G.importe) as importe,
case when G.moneda_id = PY.moneda_id then
((GXA.importe * GXAC.importe)/G.importe)
else
((GXA.importe * GXAC.importe)/G.importe) * IFNULL(TCG.tasa_cambio,0)
end as importe_moneda_base


from
gasto_x_agente GXA
inner join gasto_x_actividad GXAC on GXA.gasto_id = GXAC.gasto_id and GXA.proyecto_id = GXAC.proyecto_id
inner join agente A on GXA.agente_id = A.id
inner join actividad AC on GXAC.actividad_id = AC.id
inner join gasto G on GXA.gasto_id = G.id
inner join libro L on G.libro_id = L.id
inner join agente AI on AI.id = L.agente_id
inner join moneda M on G.moneda_id = M.id
inner join proyecto PY on GXA.proyecto_id = PY.id
left join moneda MAUX on MAUX.id = PY.moneda_id
left join tasa_cambio_gasto TCG on TCG.gasto_id = G.id and TCG.proyecto_id = PY.id
inner join partida PT on G.partida_id = PT.id
left join subpartida SPT on G.subpartida_id = SPT.id
left join partida_x_partida_financiacion PXPA on PT.id = PXPA.partida_id
left join partida_financiacion PTF on PTF.id = PXPA.partida_financiacion_id

EOI2

  end
end
