class CreaTasasCambioMonedaPrincipal < ActiveRecord::Migration
  def self.up
    # Genera las tasas de cambio de la moneda principal para presupuestos y gastos
    Etapa.all.each do |etapa|
      objeto = (etapa.proyecto || etapa.agente)
      if objeto
        puts "--------> Creando Tasas de Cambio de moneda principal para la etapa " + etapa.nombre + " del " + objeto.class.name + " " + objeto.nombre
        TasaCambio.etapa_cambia_fechas(etapa) if objeto.moneda_principal 
        puts "   *** No hay moneda principal... no se hace nada." unless objeto.moneda_principal
      else
        puts "********  Hay que revisar los datos!!!. La etapa " + etapa.nombre + " (ID:" + etapa.id.to_s + ") no tiene proyecto ni agente asociado"
      end
    end
  end

  def self.down
    Etapa.all.each do |etapa|
      objeto = (etapa.proyecto || etapa.agente)
      if objeto
        puts "--------> Eliminando Tasas de Cambio de moneda principal para la etapa " + etapa.nombre + " del " + objeto.class.name + " " + objeto.nombre
        TasaCambio.all(:conditions => {:moneda_id => objeto.moneda_id, :etapa_id => etapa.id}).each { |tc| tc.destroy }
      else
        puts "********  Hay que revisar los datos!!!. La etapa " + etapa.nombre + " (ID:" + etapa.id.to_s + ") no tiene proyecto ni agente asociado"
      end
    end
  end
end
