class AddFvConvenioToFv < ActiveRecord::Migration
  def self.up
    add_column :fuente_verificacion, :fuente_verificacion_convenio_id, :integer
    # Recargamos la info de la clase
    FuenteVerificacion.reset_column_information
    # Para todas las fuentes, buscamos si son de pac y les asignamos la fv del convenio si existe 
    FuenteVerificacion.all.each do |fv|
      objeto = (fv.objetivo_especifico || fv.resultado)

      # En el caso de que no haya oe ni resultado, sacamos un aviso 
      unless objeto
        puts "-----------> OJO!!! La FV con id " + fv.id.to_s + " no esta asociado a OE ni Resultado."
        #indicador.destroy
      end

      # Si la FV es de pac
      if objeto && objeto.proyecto && objeto.proyecto.convenio_id
        convenio_id = objeto.proyecto.convenio_id
        fv_convenio = FuenteVerificacion.first(
		:include => ["objetivo_especifico"],
		:conditions => ["fuente_verificacion.codigo = ? AND objetivo_especifico.proyecto_id = ? AND objetivo_especifico.codigo = ?", fv.codigo, convenio_id, fv.objetivo_especifico.codigo]
	) if fv.objetivo_especifico
        fv_convenio = FuenteVerificacion.first(
                :include => ["resultado"],
                :conditions => ["fuente_verificacion.codigo = ? AND resultado.proyecto_id = ? AND resultado.codigo = ?", fv.codigo, convenio_id, fv.resultado.codigo]
        ) if fv.resultado
        if fv_convenio
          fv.fuente_verificacion_convenio_id = fv_convenio.id
          fv.save
        end
      end
    end
  end

  def self.down
    remove_column :fuente_verificacion, :fuente_verificacion_convenio_id
  end
end
