# This file should contain all the record creation needed to seed the database with its default values.
# The data can then be loaded with the rake db:seed (or created alongside the db with db:setup).
#
# Examples:
#   
#   cities = City.create([{ :name => 'Chicago' }, { :name => 'Copenhagen' }])
#   Major.create(:name => 'Daley', :city => cities.first)


# OJO!!!
# Modificación de Alv. 2012/04/18
# OJO!!!

# Pais y Area Geografica

AreaGeografica.create([{ :nombre => 'Europa' }]) if AreaGeografica.count == 0
Pais.create([{ :nombre => 'España', :area_geografica_id => AreaGeografica.find_by_nombre("Europa").id }]) if Pais.count == 0
# Provincia.create([{ :nombre => 'Europa', :pais_id => '1' }]) if Provincia.count == 0
# Comunidad.create([{ :nombre => 'Madrid', :provincia_id => '1' }]) if Comunidad.count == 0
# Municipio.create([{ :nombre => 'Madrid', :comunidad_id => '1' }]) if Municipio.count == 0

# Areas de Actuacion

# Sectores de Intervencion

# Sectores Beneficiarios

# Etiquetas

# Socios
if TipoCuotaSocio.count == 0
  TipoCuotaSocio.create :tipo_cuota => 'Mensual'
  TipoCuotaSocio.create :tipo_cuota => 'Bimensual'
  TipoCuotaSocio.create :tipo_cuota => 'Trimestral'
  TipoCuotaSocio.create :tipo_cuota => 'Semestral'
  TipoCuotaSocio.create :tipo_cuota => 'Anual'
end

OrigenSocio.create([{ :origen => 'Otro' }]) if OrigenSocio.count == 0

if FormaPagoSocio.count == 0
  FormaPagoSocio.create :forma_pago => 'Cargo en Cuenta Corriente' 
  FormaPagoSocio.create :forma_pago => 'Cheque' 
  FormaPagoSocio.create :forma_pago => 'Efectivo'
  FormaPagoSocio.create :forma_pago => 'Otro' 
  FormaPagoSocio.create :forma_pago => 'Transferencia Bancaria' 
end 

NaturalezaSocio.create([{ :naturaleza => 'Otro' }]) if NaturalezaSocio.count == 0

# Usuario Administrador
Usuario.create([{ :nombre => 'admin', :contrasena => Digest::SHA1.hexdigest('admin'), :correoe => 'gong@ejemplo.org', :administracion => true, :proyectos=> true, :agentes => true, :cuadromando => true, :socios => true, :documentos => true}]) if Usuario.count == 0

# Estados de los Proyectos (WorkFlow)
if DefinicionEstado.count == 0
  DefinicionEstado.create :nombre => "Contacto", :orden => 0, :primer_estado => true
  DefinicionEstado.create :nombre => "Identificacion", :orden => 1, :estado_padre_id => DefinicionEstado.find_by_nombre("Contacto").id, :primer_estado => false, :formulacion => true
  DefinicionEstado.create :nombre => "Formulacion", :orden => 2, :estado_padre_id => DefinicionEstado.find_by_nombre("Identificacion").id, :primer_estado => false, :formulacion => true
  DefinicionEstado.create :nombre => "Ejecucion", :orden => 3, :estado_padre_id => DefinicionEstado.find_by_nombre("Formulacion").id, :primer_estado => false, :aprobado => true
  DefinicionEstado.create :nombre => "Reformulacion", :orden => 3, :estado_padre_id => DefinicionEstado.find_by_nombre("Formulacion").id, :primer_estado => false, :formulacion => true, :aprobado => true
  DefinicionEstado.create :nombre => "Cierre", :orden => 5, :estado_padre_id => DefinicionEstado.find_by_nombre("Ejecucion").id, :primer_estado => false, :cerrado => true
end

# Tipos de Tarea
if TipoTarea.count == 0
  TipoTarea.create (:nombre =>  "Datos proyecto", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Documentacion", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Presupuesto", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Gasto", :tipo_proyecto => true)
  TipoTarea.create (:nombre =>  "Matriz", :tipo_proyecto => true)
end

# Estados de las Tareas
if EstadoTarea.count == 0
  EstadoTarea.create( :nombre => "Cerrada", :descripcion => "Tarea que ya está finalizada", :activo => false)
  EstadoTarea.create( :nombre => "En curso", :descripcion => "Tarea en la cual se trabaja actualmente", :activo => true)
  EstadoTarea.create( :nombre => "En espera", :descripcion => "Tarea que todavía no ha comenzado", :activo => true)
end

# Moneda
Moneda.create(:nombre => "Euro", :abreviatura => "EUR") if Moneda.count == 0

# Agente
if Agente.count == 2
  Agente.create :nombre => "AECID", :financiador => true
  Agente.create :nombre => "ONG-INT", :financiador => true, :implementador => true
  #Agente.create :nombre => "OTRAS FINANCIACIONES PÚBLICAS", :financiador => true
  #Agente.create :nombre => "OTRAS FINANCIACIONES PRIVADAS", :financiador => true
end

# Espacios para Gestión Documental
Espacio.create :nombre => "Proyectos", :descripcion => "Espacio raiz de los espacios de proyecto. Este espacio no se puede modificar ni eliminar." if Espacio.count == 0

# Proyectos de Ejemplo
Proyecto.create(:nombre => "2011-GONG", :titulo => "Proyecto para la implantación en nuestra ONG de GONG", :moneda_id => Moneda.find_by_nombre("Euro").id, :agente_id => Agente.find_by_nombre("AECID").id) if Proyecto.count == 0

UsuarioXProyecto.create(:usuario_id => Usuario.find_by_nombre("admin").id, :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :rol => "coordinador") if UsuarioXProyecto.count == 0

# Tareas para el Usuario Admin
if Tarea.count == 0
  Tarea.create(:titulo => "Dar de alta etapas del proyecto", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Datos proyecto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Cambiar estado proyecto", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Datos proyecto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Dar de alta relaciones proyecto", :descripcion => "Se necesita dar de alta las entidades en administracion",:proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Datos proyecto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Dar de alta el presupuesto", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Presupuesto").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
  Tarea.create(:titulo => "Dar de alta la matriz", :proyecto_id => Proyecto.find_by_nombre("2011-GONG").id, :usuario_asignado_id => Usuario.find_by_nombre("admin").id, :fecha_inicio => Date.today, :tipo_tarea_id =>  TipoTarea.find_by_nombre("Matriz").id, :estado_tarea_id => EstadoTarea.find_by_nombre("en espera").id)
end

